%{
open MiniProlog
%}
%token <string> CIDENT
%token <string> LIDENT

%token LPAREN RPAREN
%token QHYPHEN CHYPHEN
%token PERIOD COMMA
%token EOF

%right COMMA

%type <MiniProlog.literal> literal
%type <MiniProlog.rule> rule
%type <MiniProlog.rule> fact
%type <MiniProlog.query> query
%type <MiniProlog.toplevel> toplevel
%start literal
%start rule
%start fact
%start query
%start toplevel
%%
i_literal:
  LIDENT { Literal($1, []) }
| LIDENT LPAREN i_termlist RPAREN { Literal($1, List.rev $3) }
;
i_termlist:
  i_term { [$1] }
| i_termlist COMMA i_term { $3 :: $1 }
;
i_term:
  CIDENT { Var $1 }
| LIDENT { Atom $1 }
| LIDENT LPAREN i_termlist RPAREN { Compound ($1, List.rev $3) }
;
i_literal_list:
  i_literal { [$1] }
| i_literal_list COMMA i_literal { $3 :: $1 }
;
i_query:
  i_literal_list { $1 }
;
i_rule:
  i_literal { $1, [] }
| i_literal CHYPHEN i_literal_list { $1, $3 }
;

literal:
  i_literal { $1 }
;
rule:
  i_rule { $1 }
;
query:
  i_query { $1 }
;
fact:
  i_literal { $1, [] }
;
toplevel:
  i_rule PERIOD { Rule $1 }
| QHYPHEN i_query PERIOD { Query $2 }
;
